=begin
#Firefly III API

#This is the official documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. This version of the API is live from version v4.7.9 and onwards. You may use the \"Authorize\" button to try the API below. 

The version of the OpenAPI document: 0.10.4-modified
Contact: thegrumpydictator@gmail.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0-SNAPSHOT

=end

require 'cgi'

module FireflyIIIClient
  class AboutApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # System information end point.
    # Returns general system information and versions of the (supporting) software. 
    # @param [Hash] opts the optional parameters
    # @return [SystemInfo]
    def get_about(opts = {})
      data, _status_code, _headers = get_about_with_http_info(opts)
      data
    end

    # System information end point.
    # Returns general system information and versions of the (supporting) software. 
    # @param [Hash] opts the optional parameters
    # @return [Array<(SystemInfo, Integer, Hash)>] SystemInfo data, response status code and response headers
    def get_about_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AboutApi.get_about ...'
      end
      # resource path
      local_var_path = '/api/v1/about'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'SystemInfo'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"AboutApi.get_about",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AboutApi#get_about\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Currently authenticated user endpoint.
    # Returns the currently authenticated user. 
    # @param [Hash] opts the optional parameters
    # @return [UserSingle]
    def get_current_user(opts = {})
      data, _status_code, _headers = get_current_user_with_http_info(opts)
      data
    end

    # Currently authenticated user endpoint.
    # Returns the currently authenticated user. 
    # @param [Hash] opts the optional parameters
    # @return [Array<(UserSingle, Integer, Hash)>] UserSingle data, response status code and response headers
    def get_current_user_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AboutApi.get_current_user ...'
      end
      # resource path
      local_var_path = '/api/v1/about/user'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'UserSingle'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"AboutApi.get_current_user",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AboutApi#get_current_user\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
