=begin
#Firefly III API

#This is the official documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. This version of the API is live from version v4.7.9 and onwards. You may use the \"Authorize\" button to try the API below. 

The version of the OpenAPI document: 0.10.4-modified
Contact: thegrumpydictator@gmail.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0-SNAPSHOT

=end

require 'cgi'

module FireflyIIIClient
  class AvailableBudgetsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Delete an available budget.
    # Delete an available budget. Not much more to say.
    # @param id [Integer] The ID of the available budget.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_available_budget(id, opts = {})
      delete_available_budget_with_http_info(id, opts)
      nil
    end

    # Delete an available budget.
    # Delete an available budget. Not much more to say.
    # @param id [Integer] The ID of the available budget.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_available_budget_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AvailableBudgetsApi.delete_available_budget ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling AvailableBudgetsApi.delete_available_budget"
      end
      # resource path
      local_var_path = '/api/v1/available_budgets/{id}'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type]

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"AvailableBudgetsApi.delete_available_budget",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AvailableBudgetsApi#delete_available_budget\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get a single available budget.
    # Get a single available budget, by ID.
    # @param id [Integer] The ID of the available budget.
    # @param [Hash] opts the optional parameters
    # @return [AvailableBudgetSingle]
    def get_available_budget(id, opts = {})
      data, _status_code, _headers = get_available_budget_with_http_info(id, opts)
      data
    end

    # Get a single available budget.
    # Get a single available budget, by ID.
    # @param id [Integer] The ID of the available budget.
    # @param [Hash] opts the optional parameters
    # @return [Array<(AvailableBudgetSingle, Integer, Hash)>] AvailableBudgetSingle data, response status code and response headers
    def get_available_budget_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AvailableBudgetsApi.get_available_budget ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling AvailableBudgetsApi.get_available_budget"
      end
      # resource path
      local_var_path = '/api/v1/available_budgets/{id}'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'AvailableBudgetSingle'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"AvailableBudgetsApi.get_available_budget",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AvailableBudgetsApi#get_available_budget\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List all available budget amounts.
    # Firefly III allows users to set the amount that is available to be budgeted in so-called \"available budgets\". For example, the user could have 1200,- available to be divided during the coming month. This amount is used on the /budgets page. This endpoint returns all of these amounts and the periods for which they are set. 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number. The default pagination is 50.
    # @option opts [Date] :start A date formatted YYYY-MM-DD. 
    # @option opts [Date] :_end A date formatted YYYY-MM-DD. 
    # @return [AvailableBudgetArray]
    def list_available_budget(opts = {})
      data, _status_code, _headers = list_available_budget_with_http_info(opts)
      data
    end

    # List all available budget amounts.
    # Firefly III allows users to set the amount that is available to be budgeted in so-called \&quot;available budgets\&quot;. For example, the user could have 1200,- available to be divided during the coming month. This amount is used on the /budgets page. This endpoint returns all of these amounts and the periods for which they are set. 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number. The default pagination is 50.
    # @option opts [Date] :start A date formatted YYYY-MM-DD. 
    # @option opts [Date] :_end A date formatted YYYY-MM-DD. 
    # @return [Array<(AvailableBudgetArray, Integer, Hash)>] AvailableBudgetArray data, response status code and response headers
    def list_available_budget_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AvailableBudgetsApi.list_available_budget ...'
      end
      # resource path
      local_var_path = '/api/v1/available_budgets'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'start'] = opts[:'start'] if !opts[:'start'].nil?
      query_params[:'end'] = opts[:'_end'] if !opts[:'_end'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'AvailableBudgetArray'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"AvailableBudgetsApi.list_available_budget",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AvailableBudgetsApi#list_available_budget\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Store a new available budget
    # Creates a new available budget for a specified period. The data required can be submitted as a JSON body or as a list of parameters. 
    # @param available_budget [AvailableBudget] JSON array or key&#x3D;value pairs with the necessary available budget information. See the model for the exact specifications.
    # @param [Hash] opts the optional parameters
    # @return [AvailableBudgetSingle]
    def store_available_budget(available_budget, opts = {})
      data, _status_code, _headers = store_available_budget_with_http_info(available_budget, opts)
      data
    end

    # Store a new available budget
    # Creates a new available budget for a specified period. The data required can be submitted as a JSON body or as a list of parameters. 
    # @param available_budget [AvailableBudget] JSON array or key&#x3D;value pairs with the necessary available budget information. See the model for the exact specifications.
    # @param [Hash] opts the optional parameters
    # @return [Array<(AvailableBudgetSingle, Integer, Hash)>] AvailableBudgetSingle data, response status code and response headers
    def store_available_budget_with_http_info(available_budget, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AvailableBudgetsApi.store_available_budget ...'
      end
      # verify the required parameter 'available_budget' is set
      if @api_client.config.client_side_validation && available_budget.nil?
        fail ArgumentError, "Missing the required parameter 'available_budget' when calling AvailableBudgetsApi.store_available_budget"
      end
      # resource path
      local_var_path = '/api/v1/available_budgets'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(available_budget)

      # return_type
      return_type = opts[:debug_return_type] || 'AvailableBudgetSingle'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"AvailableBudgetsApi.store_available_budget",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AvailableBudgetsApi#store_available_budget\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update existing available budget, to change for example the date range of the amount or the amount itself.
    # Update existing available budget.
    # @param id [Integer] The ID of the object.X
    # @param available_budget [AvailableBudget] JSON array or form value with updated available budget information. See the model for the exact specifications.
    # @param [Hash] opts the optional parameters
    # @return [AvailableBudgetSingle]
    def update_available_budget(id, available_budget, opts = {})
      data, _status_code, _headers = update_available_budget_with_http_info(id, available_budget, opts)
      data
    end

    # Update existing available budget, to change for example the date range of the amount or the amount itself.
    # Update existing available budget.
    # @param id [Integer] The ID of the object.X
    # @param available_budget [AvailableBudget] JSON array or form value with updated available budget information. See the model for the exact specifications.
    # @param [Hash] opts the optional parameters
    # @return [Array<(AvailableBudgetSingle, Integer, Hash)>] AvailableBudgetSingle data, response status code and response headers
    def update_available_budget_with_http_info(id, available_budget, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AvailableBudgetsApi.update_available_budget ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling AvailableBudgetsApi.update_available_budget"
      end
      # verify the required parameter 'available_budget' is set
      if @api_client.config.client_side_validation && available_budget.nil?
        fail ArgumentError, "Missing the required parameter 'available_budget' when calling AvailableBudgetsApi.update_available_budget"
      end
      # resource path
      local_var_path = '/api/v1/available_budgets/{id}'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(available_budget)

      # return_type
      return_type = opts[:debug_return_type] || 'AvailableBudgetSingle'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"AvailableBudgetsApi.update_available_budget",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AvailableBudgetsApi#update_available_budget\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
