=begin
#Firefly III API

#This is the official documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. This version of the API is live from version v4.7.9 and onwards. You may use the \"Authorize\" button to try the API below. 

The version of the OpenAPI document: 0.10.4-modified
Contact: thegrumpydictator@gmail.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0-SNAPSHOT

=end

require 'cgi'

module FireflyIIIClient
  class ChartsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Dashboard chart with an overview of the available budget.
    # This endpoint returns the data required to generate a pie chart for the available budget. 
    # @param id [Integer] The ID of the available budget.
    # @param start [Date] A date formatted YYYY-MM-DD. 
    # @param _end [Date] A date formatted YYYY-MM-DD. 
    # @param [Hash] opts the optional parameters
    # @return [Array<ChartDataSet>]
    def get_chart_ab_overview(id, start, _end, opts = {})
      data, _status_code, _headers = get_chart_ab_overview_with_http_info(id, start, _end, opts)
      data
    end

    # Dashboard chart with an overview of the available budget.
    # This endpoint returns the data required to generate a pie chart for the available budget. 
    # @param id [Integer] The ID of the available budget.
    # @param start [Date] A date formatted YYYY-MM-DD. 
    # @param _end [Date] A date formatted YYYY-MM-DD. 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<ChartDataSet>, Integer, Hash)>] Array<ChartDataSet> data, response status code and response headers
    def get_chart_ab_overview_with_http_info(id, start, _end, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChartsApi.get_chart_ab_overview ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling ChartsApi.get_chart_ab_overview"
      end
      # verify the required parameter 'start' is set
      if @api_client.config.client_side_validation && start.nil?
        fail ArgumentError, "Missing the required parameter 'start' when calling ChartsApi.get_chart_ab_overview"
      end
      # verify the required parameter '_end' is set
      if @api_client.config.client_side_validation && _end.nil?
        fail ArgumentError, "Missing the required parameter '_end' when calling ChartsApi.get_chart_ab_overview"
      end
      # resource path
      local_var_path = '/api/v1/chart/ab/overview/{id}'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'start'] = start
      query_params[:'end'] = _end

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Array<ChartDataSet>'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"ChartsApi.get_chart_ab_overview",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChartsApi#get_chart_ab_overview\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Dashboard chart with expense account balance information.
    # This endpoint returns the data required to generate a chart that shows the user how much they've spent on their expense accounts. 
    # @param start [Date] A date formatted YYYY-MM-DD. 
    # @param _end [Date] A date formatted YYYY-MM-DD. 
    # @param [Hash] opts the optional parameters
    # @return [Array<ChartDataSet>]
    def get_chart_account_expense(start, _end, opts = {})
      data, _status_code, _headers = get_chart_account_expense_with_http_info(start, _end, opts)
      data
    end

    # Dashboard chart with expense account balance information.
    # This endpoint returns the data required to generate a chart that shows the user how much they&#39;ve spent on their expense accounts. 
    # @param start [Date] A date formatted YYYY-MM-DD. 
    # @param _end [Date] A date formatted YYYY-MM-DD. 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<ChartDataSet>, Integer, Hash)>] Array<ChartDataSet> data, response status code and response headers
    def get_chart_account_expense_with_http_info(start, _end, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChartsApi.get_chart_account_expense ...'
      end
      # verify the required parameter 'start' is set
      if @api_client.config.client_side_validation && start.nil?
        fail ArgumentError, "Missing the required parameter 'start' when calling ChartsApi.get_chart_account_expense"
      end
      # verify the required parameter '_end' is set
      if @api_client.config.client_side_validation && _end.nil?
        fail ArgumentError, "Missing the required parameter '_end' when calling ChartsApi.get_chart_account_expense"
      end
      # resource path
      local_var_path = '/api/v1/chart/account/expense'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'start'] = start
      query_params[:'end'] = _end

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Array<ChartDataSet>'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"ChartsApi.get_chart_account_expense",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChartsApi#get_chart_account_expense\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Dashboard chart with asset account balance information.
    # This endpoint returns the data required to generate a chart with basic asset account balance information. 
    # @param start [Date] A date formatted YYYY-MM-DD. 
    # @param _end [Date] A date formatted YYYY-MM-DD. 
    # @param [Hash] opts the optional parameters
    # @return [Array<ChartDataSet>]
    def get_chart_account_overview(start, _end, opts = {})
      data, _status_code, _headers = get_chart_account_overview_with_http_info(start, _end, opts)
      data
    end

    # Dashboard chart with asset account balance information.
    # This endpoint returns the data required to generate a chart with basic asset account balance information. 
    # @param start [Date] A date formatted YYYY-MM-DD. 
    # @param _end [Date] A date formatted YYYY-MM-DD. 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<ChartDataSet>, Integer, Hash)>] Array<ChartDataSet> data, response status code and response headers
    def get_chart_account_overview_with_http_info(start, _end, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChartsApi.get_chart_account_overview ...'
      end
      # verify the required parameter 'start' is set
      if @api_client.config.client_side_validation && start.nil?
        fail ArgumentError, "Missing the required parameter 'start' when calling ChartsApi.get_chart_account_overview"
      end
      # verify the required parameter '_end' is set
      if @api_client.config.client_side_validation && _end.nil?
        fail ArgumentError, "Missing the required parameter '_end' when calling ChartsApi.get_chart_account_overview"
      end
      # resource path
      local_var_path = '/api/v1/chart/account/overview'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'start'] = start
      query_params[:'end'] = _end

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Array<ChartDataSet>'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"ChartsApi.get_chart_account_overview",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChartsApi#get_chart_account_overview\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Dashboard chart with revenue account balance information.
    # This endpoint returns the data required to generate a chart that shows the user how much they've earned from their revenue accounts. 
    # @param start [Date] A date formatted YYYY-MM-DD. 
    # @param _end [Date] A date formatted YYYY-MM-DD. 
    # @param [Hash] opts the optional parameters
    # @return [Array<ChartDataSet>]
    def get_chart_account_revenue(start, _end, opts = {})
      data, _status_code, _headers = get_chart_account_revenue_with_http_info(start, _end, opts)
      data
    end

    # Dashboard chart with revenue account balance information.
    # This endpoint returns the data required to generate a chart that shows the user how much they&#39;ve earned from their revenue accounts. 
    # @param start [Date] A date formatted YYYY-MM-DD. 
    # @param _end [Date] A date formatted YYYY-MM-DD. 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<ChartDataSet>, Integer, Hash)>] Array<ChartDataSet> data, response status code and response headers
    def get_chart_account_revenue_with_http_info(start, _end, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChartsApi.get_chart_account_revenue ...'
      end
      # verify the required parameter 'start' is set
      if @api_client.config.client_side_validation && start.nil?
        fail ArgumentError, "Missing the required parameter 'start' when calling ChartsApi.get_chart_account_revenue"
      end
      # verify the required parameter '_end' is set
      if @api_client.config.client_side_validation && _end.nil?
        fail ArgumentError, "Missing the required parameter '_end' when calling ChartsApi.get_chart_account_revenue"
      end
      # resource path
      local_var_path = '/api/v1/chart/account/revenue'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'start'] = start
      query_params[:'end'] = _end

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Array<ChartDataSet>'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"ChartsApi.get_chart_account_revenue",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChartsApi#get_chart_account_revenue\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Dashboard chart with an overview of the users categories.
    # This endpoint returns the data required to generate a bar chart for the expenses and incomes on the users categories. 
    # @param start [Date] A date formatted YYYY-MM-DD. 
    # @param _end [Date] A date formatted YYYY-MM-DD. 
    # @param [Hash] opts the optional parameters
    # @return [Array<ChartDataSet>]
    def get_chart_category_overview(start, _end, opts = {})
      data, _status_code, _headers = get_chart_category_overview_with_http_info(start, _end, opts)
      data
    end

    # Dashboard chart with an overview of the users categories.
    # This endpoint returns the data required to generate a bar chart for the expenses and incomes on the users categories. 
    # @param start [Date] A date formatted YYYY-MM-DD. 
    # @param _end [Date] A date formatted YYYY-MM-DD. 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<ChartDataSet>, Integer, Hash)>] Array<ChartDataSet> data, response status code and response headers
    def get_chart_category_overview_with_http_info(start, _end, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ChartsApi.get_chart_category_overview ...'
      end
      # verify the required parameter 'start' is set
      if @api_client.config.client_side_validation && start.nil?
        fail ArgumentError, "Missing the required parameter 'start' when calling ChartsApi.get_chart_category_overview"
      end
      # verify the required parameter '_end' is set
      if @api_client.config.client_side_validation && _end.nil?
        fail ArgumentError, "Missing the required parameter '_end' when calling ChartsApi.get_chart_category_overview"
      end
      # resource path
      local_var_path = '/api/v1/chart/category/overview'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'start'] = start
      query_params[:'end'] = _end

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Array<ChartDataSet>'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"ChartsApi.get_chart_category_overview",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ChartsApi#get_chart_category_overview\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
