=begin
#Firefly III API

#This is the official documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. This version of the API is live from version v4.7.9 and onwards. You may use the \"Authorize\" button to try the API below. 

The version of the OpenAPI document: 0.10.4-modified
Contact: thegrumpydictator@gmail.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0-SNAPSHOT

=end

require 'cgi'

module FireflyIIIClient
  class ImportApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Show info on a single import
    # Show info on single import.
    # @param key [String] The job key of an import job.
    # @param [Hash] opts the optional parameters
    # @return [ImportJobSingle]
    def get_import(key, opts = {})
      data, _status_code, _headers = get_import_with_http_info(key, opts)
      data
    end

    # Show info on a single import
    # Show info on single import.
    # @param key [String] The job key of an import job.
    # @param [Hash] opts the optional parameters
    # @return [Array<(ImportJobSingle, Integer, Hash)>] ImportJobSingle data, response status code and response headers
    def get_import_with_http_info(key, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImportApi.get_import ...'
      end
      # verify the required parameter 'key' is set
      if @api_client.config.client_side_validation && key.nil?
        fail ArgumentError, "Missing the required parameter 'key' when calling ImportApi.get_import"
      end
      # resource path
      local_var_path = '/api/v1/import/{key}'.sub('{' + 'key' + '}', CGI.escape(key.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'ImportJobSingle'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"ImportApi.get_import",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImportApi#get_import\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List al imports
    # List all imports
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number. The default pagination is per 50 items.
    # @return [ImportJobArray]
    def list_import(opts = {})
      data, _status_code, _headers = list_import_with_http_info(opts)
      data
    end

    # List al imports
    # List all imports
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number. The default pagination is per 50 items.
    # @return [Array<(ImportJobArray, Integer, Hash)>] ImportJobArray data, response status code and response headers
    def list_import_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImportApi.list_import ...'
      end
      # resource path
      local_var_path = '/api/v1/import/list'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'ImportJobArray'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"ImportApi.list_import",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImportApi#list_import\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List all transactions related to the import job. The correlation is made through the tag.
    # See summary 
    # @param key [String] The key of the import job
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number. The default pagination is 50.
    # @option opts [Date] :start A date formatted YYYY-MM-DD. This is the start date of the selected range (inclusive). 
    # @option opts [Date] :_end A date formatted YYYY-MM-DD. This is the end date of the selected range (inclusive). 
    # @option opts [TransactionTypeFilter] :type Optional filter on the transaction type(s) returned.
    # @return [TransactionArray]
    def list_transaction_by_import(key, opts = {})
      data, _status_code, _headers = list_transaction_by_import_with_http_info(key, opts)
      data
    end

    # List all transactions related to the import job. The correlation is made through the tag.
    # See summary 
    # @param key [String] The key of the import job
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number. The default pagination is 50.
    # @option opts [Date] :start A date formatted YYYY-MM-DD. This is the start date of the selected range (inclusive). 
    # @option opts [Date] :_end A date formatted YYYY-MM-DD. This is the end date of the selected range (inclusive). 
    # @option opts [TransactionTypeFilter] :type Optional filter on the transaction type(s) returned.
    # @return [Array<(TransactionArray, Integer, Hash)>] TransactionArray data, response status code and response headers
    def list_transaction_by_import_with_http_info(key, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImportApi.list_transaction_by_import ...'
      end
      # verify the required parameter 'key' is set
      if @api_client.config.client_side_validation && key.nil?
        fail ArgumentError, "Missing the required parameter 'key' when calling ImportApi.list_transaction_by_import"
      end
      # resource path
      local_var_path = '/api/v1/import/{key}/transactions'.sub('{' + 'key' + '}', CGI.escape(key.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'start'] = opts[:'start'] if !opts[:'start'].nil?
      query_params[:'end'] = opts[:'_end'] if !opts[:'_end'].nil?
      query_params[:'type'] = opts[:'type'] if !opts[:'type'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'TransactionArray'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"ImportApi.list_transaction_by_import",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImportApi#list_transaction_by_import\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
