=begin
#Firefly III API

#This is the official documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. This version of the API is live from version v4.7.9 and onwards. You may use the \"Authorize\" button to try the API below. 

The version of the OpenAPI document: 0.10.4-modified
Contact: thegrumpydictator@gmail.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0-SNAPSHOT

=end

require 'cgi'

module FireflyIIIClient
  class LinksApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Permanently delete link type.
    # Will permanently delete a link type. The links between transactions will be removed. The transactions themselves remain. You cannot delete some of the system provided link types, indicated by the editable=false flag when you list it. 
    # @param id [Integer] The ID of the link type.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_link_type(id, opts = {})
      delete_link_type_with_http_info(id, opts)
      nil
    end

    # Permanently delete link type.
    # Will permanently delete a link type. The links between transactions will be removed. The transactions themselves remain. You cannot delete some of the system provided link types, indicated by the editable&#x3D;false flag when you list it. 
    # @param id [Integer] The ID of the link type.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_link_type_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LinksApi.delete_link_type ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling LinksApi.delete_link_type"
      end
      # resource path
      local_var_path = '/api/v1/link_types/{id}'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type]

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"LinksApi.delete_link_type",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LinksApi#delete_link_type\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Permanently delete link between transactions.
    # Will permanently delete link. Transactions remain. 
    # @param id [Integer] The ID of the transaction link.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_transaction_link(id, opts = {})
      delete_transaction_link_with_http_info(id, opts)
      nil
    end

    # Permanently delete link between transactions.
    # Will permanently delete link. Transactions remain. 
    # @param id [Integer] The ID of the transaction link.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_transaction_link_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LinksApi.delete_transaction_link ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling LinksApi.delete_transaction_link"
      end
      # resource path
      local_var_path = '/api/v1/transaction_links/{id}'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type]

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"LinksApi.delete_transaction_link",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LinksApi#delete_transaction_link\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get single a link type.
    # Returns a single link type by its ID. 
    # @param id [Integer] The ID of the link type.
    # @param [Hash] opts the optional parameters
    # @return [LinkTypeSingle]
    def get_link_type(id, opts = {})
      data, _status_code, _headers = get_link_type_with_http_info(id, opts)
      data
    end

    # Get single a link type.
    # Returns a single link type by its ID. 
    # @param id [Integer] The ID of the link type.
    # @param [Hash] opts the optional parameters
    # @return [Array<(LinkTypeSingle, Integer, Hash)>] LinkTypeSingle data, response status code and response headers
    def get_link_type_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LinksApi.get_link_type ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling LinksApi.get_link_type"
      end
      # resource path
      local_var_path = '/api/v1/link_types/{id}'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'LinkTypeSingle'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"LinksApi.get_link_type",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LinksApi#get_link_type\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get a single link.
    # Returns a single link by its ID. 
    # @param id [Integer] The ID of the transaction link.
    # @param [Hash] opts the optional parameters
    # @return [TransactionLinkSingle]
    def get_transaction_link(id, opts = {})
      data, _status_code, _headers = get_transaction_link_with_http_info(id, opts)
      data
    end

    # Get a single link.
    # Returns a single link by its ID. 
    # @param id [Integer] The ID of the transaction link.
    # @param [Hash] opts the optional parameters
    # @return [Array<(TransactionLinkSingle, Integer, Hash)>] TransactionLinkSingle data, response status code and response headers
    def get_transaction_link_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LinksApi.get_transaction_link ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling LinksApi.get_transaction_link"
      end
      # resource path
      local_var_path = '/api/v1/transaction_links/{id}'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'TransactionLinkSingle'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"LinksApi.get_transaction_link",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LinksApi#get_transaction_link\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List all types of links.
    # List all the link types the system has. These include the default ones as well as any new ones. 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number. The default pagination is 50 items.
    # @return [LinkTypeArray]
    def list_link_type(opts = {})
      data, _status_code, _headers = list_link_type_with_http_info(opts)
      data
    end

    # List all types of links.
    # List all the link types the system has. These include the default ones as well as any new ones. 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number. The default pagination is 50 items.
    # @return [Array<(LinkTypeArray, Integer, Hash)>] LinkTypeArray data, response status code and response headers
    def list_link_type_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LinksApi.list_link_type ...'
      end
      # resource path
      local_var_path = '/api/v1/link_types'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'LinkTypeArray'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"LinksApi.list_link_type",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LinksApi#list_link_type\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List all transactions under this link type.
    # List all transactions under this link type, both the inward and outward transactions. 
    # @param id [Integer] The ID of the link type.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number. The default pagination is per 50 items.
    # @option opts [Date] :start A date formatted YYYY-MM-DD, to limit the results. 
    # @option opts [Date] :_end A date formatted YYYY-MM-DD, to limit the results. 
    # @option opts [TransactionTypeFilter] :type Optional filter on the transaction type(s) returned.
    # @return [TransactionArray]
    def list_transaction_by_link_type(id, opts = {})
      data, _status_code, _headers = list_transaction_by_link_type_with_http_info(id, opts)
      data
    end

    # List all transactions under this link type.
    # List all transactions under this link type, both the inward and outward transactions. 
    # @param id [Integer] The ID of the link type.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number. The default pagination is per 50 items.
    # @option opts [Date] :start A date formatted YYYY-MM-DD, to limit the results. 
    # @option opts [Date] :_end A date formatted YYYY-MM-DD, to limit the results. 
    # @option opts [TransactionTypeFilter] :type Optional filter on the transaction type(s) returned.
    # @return [Array<(TransactionArray, Integer, Hash)>] TransactionArray data, response status code and response headers
    def list_transaction_by_link_type_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LinksApi.list_transaction_by_link_type ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling LinksApi.list_transaction_by_link_type"
      end
      # resource path
      local_var_path = '/api/v1/link_types/{id}/transactions'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'start'] = opts[:'start'] if !opts[:'start'].nil?
      query_params[:'end'] = opts[:'_end'] if !opts[:'_end'].nil?
      query_params[:'type'] = opts[:'type'] if !opts[:'type'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'TransactionArray'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"LinksApi.list_transaction_by_link_type",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LinksApi#list_transaction_by_link_type\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List all transaction links.
    # List all the transaction links. 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number. The default pagination is per 50 items.
    # @return [TransactionLinkArray]
    def list_transaction_link(opts = {})
      data, _status_code, _headers = list_transaction_link_with_http_info(opts)
      data
    end

    # List all transaction links.
    # List all the transaction links. 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number. The default pagination is per 50 items.
    # @return [Array<(TransactionLinkArray, Integer, Hash)>] TransactionLinkArray data, response status code and response headers
    def list_transaction_link_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LinksApi.list_transaction_link ...'
      end
      # resource path
      local_var_path = '/api/v1/transaction_links'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'TransactionLinkArray'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"LinksApi.list_transaction_link",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LinksApi#list_transaction_link\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create a new link type
    # Creates a new link type. The data required can be submitted as a JSON body or as a list of parameters (in key=value pairs, like a webform).
    # @param link_type [LinkType] JSON array with the necessary link type information or key&#x3D;value pairs. See the model for the exact specifications.
    # @param [Hash] opts the optional parameters
    # @return [LinkTypeSingle]
    def store_link_type(link_type, opts = {})
      data, _status_code, _headers = store_link_type_with_http_info(link_type, opts)
      data
    end

    # Create a new link type
    # Creates a new link type. The data required can be submitted as a JSON body or as a list of parameters (in key&#x3D;value pairs, like a webform).
    # @param link_type [LinkType] JSON array with the necessary link type information or key&#x3D;value pairs. See the model for the exact specifications.
    # @param [Hash] opts the optional parameters
    # @return [Array<(LinkTypeSingle, Integer, Hash)>] LinkTypeSingle data, response status code and response headers
    def store_link_type_with_http_info(link_type, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LinksApi.store_link_type ...'
      end
      # verify the required parameter 'link_type' is set
      if @api_client.config.client_side_validation && link_type.nil?
        fail ArgumentError, "Missing the required parameter 'link_type' when calling LinksApi.store_link_type"
      end
      # resource path
      local_var_path = '/api/v1/link_types'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(link_type)

      # return_type
      return_type = opts[:debug_return_type] || 'LinkTypeSingle'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"LinksApi.store_link_type",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LinksApi#store_link_type\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create a new link between transactions
    # Store a new link between two transactions. For this end point you need the journal_id from a transaction.
    # @param transaction_link [TransactionLink] JSON array with the necessary link type information or key&#x3D;value pairs. See the model for the exact specifications.
    # @param [Hash] opts the optional parameters
    # @return [TransactionLinkSingle]
    def store_transaction_link(transaction_link, opts = {})
      data, _status_code, _headers = store_transaction_link_with_http_info(transaction_link, opts)
      data
    end

    # Create a new link between transactions
    # Store a new link between two transactions. For this end point you need the journal_id from a transaction.
    # @param transaction_link [TransactionLink] JSON array with the necessary link type information or key&#x3D;value pairs. See the model for the exact specifications.
    # @param [Hash] opts the optional parameters
    # @return [Array<(TransactionLinkSingle, Integer, Hash)>] TransactionLinkSingle data, response status code and response headers
    def store_transaction_link_with_http_info(transaction_link, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LinksApi.store_transaction_link ...'
      end
      # verify the required parameter 'transaction_link' is set
      if @api_client.config.client_side_validation && transaction_link.nil?
        fail ArgumentError, "Missing the required parameter 'transaction_link' when calling LinksApi.store_transaction_link"
      end
      # resource path
      local_var_path = '/api/v1/transaction_links'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(transaction_link)

      # return_type
      return_type = opts[:debug_return_type] || 'TransactionLinkSingle'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"LinksApi.store_transaction_link",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LinksApi#store_transaction_link\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update existing link type.
    # Used to update a single link type. All fields that are not submitted will be cleared (set to NULL). The model will tell you which fields are mandatory. You cannot update some of the system provided link types, indicated by the editable=false flag when you list it. 
    # @param id [Integer] The ID of the link type.
    # @param link_type [LinkType] JSON array or formdata with updated link type information. See the model for the exact specifications.
    # @param [Hash] opts the optional parameters
    # @return [LinkTypeSingle]
    def update_link_type(id, link_type, opts = {})
      data, _status_code, _headers = update_link_type_with_http_info(id, link_type, opts)
      data
    end

    # Update existing link type.
    # Used to update a single link type. All fields that are not submitted will be cleared (set to NULL). The model will tell you which fields are mandatory. You cannot update some of the system provided link types, indicated by the editable&#x3D;false flag when you list it. 
    # @param id [Integer] The ID of the link type.
    # @param link_type [LinkType] JSON array or formdata with updated link type information. See the model for the exact specifications.
    # @param [Hash] opts the optional parameters
    # @return [Array<(LinkTypeSingle, Integer, Hash)>] LinkTypeSingle data, response status code and response headers
    def update_link_type_with_http_info(id, link_type, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LinksApi.update_link_type ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling LinksApi.update_link_type"
      end
      # verify the required parameter 'link_type' is set
      if @api_client.config.client_side_validation && link_type.nil?
        fail ArgumentError, "Missing the required parameter 'link_type' when calling LinksApi.update_link_type"
      end
      # resource path
      local_var_path = '/api/v1/link_types/{id}'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(link_type)

      # return_type
      return_type = opts[:debug_return_type] || 'LinkTypeSingle'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"LinksApi.update_link_type",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LinksApi#update_link_type\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update an existing link between transactions.
    # Used to update a single existing link. 
    # @param id [Integer] The ID of the transaction link.
    # @param transaction_link [TransactionLink] JSON array or formdata with updated link type information. See the model for the exact specifications.
    # @param [Hash] opts the optional parameters
    # @return [TransactionLinkSingle]
    def update_transaction_link(id, transaction_link, opts = {})
      data, _status_code, _headers = update_transaction_link_with_http_info(id, transaction_link, opts)
      data
    end

    # Update an existing link between transactions.
    # Used to update a single existing link. 
    # @param id [Integer] The ID of the transaction link.
    # @param transaction_link [TransactionLink] JSON array or formdata with updated link type information. See the model for the exact specifications.
    # @param [Hash] opts the optional parameters
    # @return [Array<(TransactionLinkSingle, Integer, Hash)>] TransactionLinkSingle data, response status code and response headers
    def update_transaction_link_with_http_info(id, transaction_link, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LinksApi.update_transaction_link ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling LinksApi.update_transaction_link"
      end
      # verify the required parameter 'transaction_link' is set
      if @api_client.config.client_side_validation && transaction_link.nil?
        fail ArgumentError, "Missing the required parameter 'transaction_link' when calling LinksApi.update_transaction_link"
      end
      # resource path
      local_var_path = '/api/v1/transaction_links/{id}'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(transaction_link)

      # return_type
      return_type = opts[:debug_return_type] || 'TransactionLinkSingle'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"LinksApi.update_transaction_link",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LinksApi#update_transaction_link\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
