=begin
#Firefly III API

#This is the official documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. This version of the API is live from version v4.7.9 and onwards. You may use the \"Authorize\" button to try the API below. 

The version of the OpenAPI document: 0.10.4-modified
Contact: thegrumpydictator@gmail.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0-SNAPSHOT

=end

require 'cgi'

module FireflyIIIClient
  class SummaryApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Returns basic sums of the users data.
    # Returns basic sums of the users data, like the net worth, spent and earned amounts. It is multi-currency, and is in Firefly III to populate the dashboard. 
    # @param start [Date] A date formatted YYYY-MM-DD. 
    # @param _end [Date] A date formatted YYYY-MM-DD. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :currency_code A currency code like EUR or USD, to filter the result. 
    # @return [Array<BasicSummaryEntry>]
    def get_basic_summary(start, _end, opts = {})
      data, _status_code, _headers = get_basic_summary_with_http_info(start, _end, opts)
      data
    end

    # Returns basic sums of the users data.
    # Returns basic sums of the users data, like the net worth, spent and earned amounts. It is multi-currency, and is in Firefly III to populate the dashboard. 
    # @param start [Date] A date formatted YYYY-MM-DD. 
    # @param _end [Date] A date formatted YYYY-MM-DD. 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :currency_code A currency code like EUR or USD, to filter the result. 
    # @return [Array<(Array<BasicSummaryEntry>, Integer, Hash)>] Array<BasicSummaryEntry> data, response status code and response headers
    def get_basic_summary_with_http_info(start, _end, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: SummaryApi.get_basic_summary ...'
      end
      # verify the required parameter 'start' is set
      if @api_client.config.client_side_validation && start.nil?
        fail ArgumentError, "Missing the required parameter 'start' when calling SummaryApi.get_basic_summary"
      end
      # verify the required parameter '_end' is set
      if @api_client.config.client_side_validation && _end.nil?
        fail ArgumentError, "Missing the required parameter '_end' when calling SummaryApi.get_basic_summary"
      end
      # resource path
      local_var_path = '/api/v1/summary/basic'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'start'] = start
      query_params[:'end'] = _end
      query_params[:'currency_code'] = opts[:'currency_code'] if !opts[:'currency_code'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Array<BasicSummaryEntry>'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"SummaryApi.get_basic_summary",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: SummaryApi#get_basic_summary\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
