=begin
#Firefly III API

#This is the official documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. This version of the API is live from version v4.7.9 and onwards. You may use the \"Authorize\" button to try the API below. 

The version of the OpenAPI document: 0.10.4-modified
Contact: thegrumpydictator@gmail.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0-SNAPSHOT

=end

require 'cgi'

module FireflyIIIClient
  class TagsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Delete an tag.
    # Delete an tag.
    # @param tag [String] Either the tag itself or the tag ID.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_tag(tag, opts = {})
      delete_tag_with_http_info(tag, opts)
      nil
    end

    # Delete an tag.
    # Delete an tag.
    # @param tag [String] Either the tag itself or the tag ID.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_tag_with_http_info(tag, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TagsApi.delete_tag ...'
      end
      # verify the required parameter 'tag' is set
      if @api_client.config.client_side_validation && tag.nil?
        fail ArgumentError, "Missing the required parameter 'tag' when calling TagsApi.delete_tag"
      end
      # resource path
      local_var_path = '/api/v1/tags/{tag}'.sub('{' + 'tag' + '}', CGI.escape(tag.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type]

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"TagsApi.delete_tag",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TagsApi#delete_tag\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get a single tag.
    # Get a single tag.
    # @param tag [String] Either the tag itself or the tag ID.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number
    # @return [TagSingle]
    def get_tag(tag, opts = {})
      data, _status_code, _headers = get_tag_with_http_info(tag, opts)
      data
    end

    # Get a single tag.
    # Get a single tag.
    # @param tag [String] Either the tag itself or the tag ID.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number
    # @return [Array<(TagSingle, Integer, Hash)>] TagSingle data, response status code and response headers
    def get_tag_with_http_info(tag, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TagsApi.get_tag ...'
      end
      # verify the required parameter 'tag' is set
      if @api_client.config.client_side_validation && tag.nil?
        fail ArgumentError, "Missing the required parameter 'tag' when calling TagsApi.get_tag"
      end
      # resource path
      local_var_path = '/api/v1/tags/{tag}'.sub('{' + 'tag' + '}', CGI.escape(tag.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'TagSingle'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"TagsApi.get_tag",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TagsApi#get_tag\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns a basic tag cloud.
    # Returns a list of tags, which can be used to draw a basic tag cloud.
    # @param start [Date] A date formatted YYYY-MM-DD. 
    # @param _end [Date] A date formatted YYYY-MM-DD. 
    # @param [Hash] opts the optional parameters
    # @return [TagCloud]
    def get_tag_cloud(start, _end, opts = {})
      data, _status_code, _headers = get_tag_cloud_with_http_info(start, _end, opts)
      data
    end

    # Returns a basic tag cloud.
    # Returns a list of tags, which can be used to draw a basic tag cloud.
    # @param start [Date] A date formatted YYYY-MM-DD. 
    # @param _end [Date] A date formatted YYYY-MM-DD. 
    # @param [Hash] opts the optional parameters
    # @return [Array<(TagCloud, Integer, Hash)>] TagCloud data, response status code and response headers
    def get_tag_cloud_with_http_info(start, _end, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TagsApi.get_tag_cloud ...'
      end
      # verify the required parameter 'start' is set
      if @api_client.config.client_side_validation && start.nil?
        fail ArgumentError, "Missing the required parameter 'start' when calling TagsApi.get_tag_cloud"
      end
      # verify the required parameter '_end' is set
      if @api_client.config.client_side_validation && _end.nil?
        fail ArgumentError, "Missing the required parameter '_end' when calling TagsApi.get_tag_cloud"
      end
      # resource path
      local_var_path = '/api/v1/tag-cloud'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'start'] = start
      query_params[:'end'] = _end

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'TagCloud'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"TagsApi.get_tag_cloud",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TagsApi#get_tag_cloud\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List all tags.
    # List all of the user's tags.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number
    # @return [TagArray]
    def list_tag(opts = {})
      data, _status_code, _headers = list_tag_with_http_info(opts)
      data
    end

    # List all tags.
    # List all of the user&#39;s tags.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number
    # @return [Array<(TagArray, Integer, Hash)>] TagArray data, response status code and response headers
    def list_tag_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TagsApi.list_tag ...'
      end
      # resource path
      local_var_path = '/api/v1/tags'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'TagArray'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"TagsApi.list_tag",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TagsApi#list_tag\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List all transactions with this tag.
    # List all transactions with this tag.
    # @param tag [String] Either the tag itself or the tag ID.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number. The default pagination is 50.
    # @option opts [Date] :start A date formatted YYYY-MM-DD. This is the start date of the selected range (inclusive). 
    # @option opts [Date] :_end A date formatted YYYY-MM-DD. This is the end date of the selected range (inclusive). 
    # @option opts [TransactionTypeFilter] :type Optional filter on the transaction type(s) returned.
    # @return [TransactionArray]
    def list_transaction_by_tag(tag, opts = {})
      data, _status_code, _headers = list_transaction_by_tag_with_http_info(tag, opts)
      data
    end

    # List all transactions with this tag.
    # List all transactions with this tag.
    # @param tag [String] Either the tag itself or the tag ID.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number. The default pagination is 50.
    # @option opts [Date] :start A date formatted YYYY-MM-DD. This is the start date of the selected range (inclusive). 
    # @option opts [Date] :_end A date formatted YYYY-MM-DD. This is the end date of the selected range (inclusive). 
    # @option opts [TransactionTypeFilter] :type Optional filter on the transaction type(s) returned.
    # @return [Array<(TransactionArray, Integer, Hash)>] TransactionArray data, response status code and response headers
    def list_transaction_by_tag_with_http_info(tag, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TagsApi.list_transaction_by_tag ...'
      end
      # verify the required parameter 'tag' is set
      if @api_client.config.client_side_validation && tag.nil?
        fail ArgumentError, "Missing the required parameter 'tag' when calling TagsApi.list_transaction_by_tag"
      end
      # resource path
      local_var_path = '/api/v1/tags/{tag}/transactions'.sub('{' + 'tag' + '}', CGI.escape(tag.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'start'] = opts[:'start'] if !opts[:'start'].nil?
      query_params[:'end'] = opts[:'_end'] if !opts[:'_end'].nil?
      query_params[:'type'] = opts[:'type'] if !opts[:'type'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'TransactionArray'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"TagsApi.list_transaction_by_tag",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TagsApi#list_transaction_by_tag\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Store a new tag
    # Creates a new tag. The data required can be submitted as a JSON body or as a list of parameters.
    # @param tag_model [TagModel] JSON array or key&#x3D;value pairs with the necessary tag information. See the model for the exact specifications.
    # @param [Hash] opts the optional parameters
    # @return [TagSingle]
    def store_tag(tag_model, opts = {})
      data, _status_code, _headers = store_tag_with_http_info(tag_model, opts)
      data
    end

    # Store a new tag
    # Creates a new tag. The data required can be submitted as a JSON body or as a list of parameters.
    # @param tag_model [TagModel] JSON array or key&#x3D;value pairs with the necessary tag information. See the model for the exact specifications.
    # @param [Hash] opts the optional parameters
    # @return [Array<(TagSingle, Integer, Hash)>] TagSingle data, response status code and response headers
    def store_tag_with_http_info(tag_model, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TagsApi.store_tag ...'
      end
      # verify the required parameter 'tag_model' is set
      if @api_client.config.client_side_validation && tag_model.nil?
        fail ArgumentError, "Missing the required parameter 'tag_model' when calling TagsApi.store_tag"
      end
      # resource path
      local_var_path = '/api/v1/tags'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(tag_model)

      # return_type
      return_type = opts[:debug_return_type] || 'TagSingle'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"TagsApi.store_tag",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TagsApi#store_tag\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update existing tag.
    # Update existing tag.
    # @param tag [String] Either the tag itself or the tag ID.
    # @param tag_model [TagModel] JSON array with updated tag information. See the model for the exact specifications.
    # @param [Hash] opts the optional parameters
    # @return [TagSingle]
    def update_tag(tag, tag_model, opts = {})
      data, _status_code, _headers = update_tag_with_http_info(tag, tag_model, opts)
      data
    end

    # Update existing tag.
    # Update existing tag.
    # @param tag [String] Either the tag itself or the tag ID.
    # @param tag_model [TagModel] JSON array with updated tag information. See the model for the exact specifications.
    # @param [Hash] opts the optional parameters
    # @return [Array<(TagSingle, Integer, Hash)>] TagSingle data, response status code and response headers
    def update_tag_with_http_info(tag, tag_model, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TagsApi.update_tag ...'
      end
      # verify the required parameter 'tag' is set
      if @api_client.config.client_side_validation && tag.nil?
        fail ArgumentError, "Missing the required parameter 'tag' when calling TagsApi.update_tag"
      end
      # verify the required parameter 'tag_model' is set
      if @api_client.config.client_side_validation && tag_model.nil?
        fail ArgumentError, "Missing the required parameter 'tag_model' when calling TagsApi.update_tag"
      end
      # resource path
      local_var_path = '/api/v1/tags/{tag}'.sub('{' + 'tag' + '}', CGI.escape(tag.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(tag_model)

      # return_type
      return_type = opts[:debug_return_type] || 'TagSingle'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"TagsApi.update_tag",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TagsApi#update_tag\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
