=begin
#Firefly III API

#This is the official documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. This version of the API is live from version v4.7.9 and onwards. You may use the \"Authorize\" button to try the API below. 

The version of the OpenAPI document: 0.10.4-modified
Contact: thegrumpydictator@gmail.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0-SNAPSHOT

=end

require 'cgi'

module FireflyIIIClient
  class TransactionsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Delete a transaction.
    # Delete a transaction.
    # @param id [Integer] The ID of the transaction.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_transaction(id, opts = {})
      delete_transaction_with_http_info(id, opts)
      nil
    end

    # Delete a transaction.
    # Delete a transaction.
    # @param id [Integer] The ID of the transaction.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_transaction_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionsApi.delete_transaction ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling TransactionsApi.delete_transaction"
      end
      # resource path
      local_var_path = '/api/v1/transactions/{id}'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type]

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"TransactionsApi.delete_transaction",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionsApi#delete_transaction\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get a single transaction.
    # Get a single transaction.
    # @param id [Integer] The ID of the transaction.
    # @param [Hash] opts the optional parameters
    # @return [TransactionSingle]
    def get_transaction(id, opts = {})
      data, _status_code, _headers = get_transaction_with_http_info(id, opts)
      data
    end

    # Get a single transaction.
    # Get a single transaction.
    # @param id [Integer] The ID of the transaction.
    # @param [Hash] opts the optional parameters
    # @return [Array<(TransactionSingle, Integer, Hash)>] TransactionSingle data, response status code and response headers
    def get_transaction_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionsApi.get_transaction ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling TransactionsApi.get_transaction"
      end
      # resource path
      local_var_path = '/api/v1/transactions/{id}'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'TransactionSingle'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"TransactionsApi.get_transaction",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionsApi#get_transaction\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get a single transaction, based on one of the underlying transaction journals.
    # Get a single transaction by underlying journal.
    # @param id [Integer] The ID of the transaction journal.
    # @param [Hash] opts the optional parameters
    # @return [TransactionSingle]
    def get_transaction_by_journal(id, opts = {})
      data, _status_code, _headers = get_transaction_by_journal_with_http_info(id, opts)
      data
    end

    # Get a single transaction, based on one of the underlying transaction journals.
    # Get a single transaction by underlying journal.
    # @param id [Integer] The ID of the transaction journal.
    # @param [Hash] opts the optional parameters
    # @return [Array<(TransactionSingle, Integer, Hash)>] TransactionSingle data, response status code and response headers
    def get_transaction_by_journal_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionsApi.get_transaction_by_journal ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling TransactionsApi.get_transaction_by_journal"
      end
      # resource path
      local_var_path = '/api/v1/transaction-journals/{id}'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'TransactionSingle'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"TransactionsApi.get_transaction_by_journal",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionsApi#get_transaction_by_journal\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Lists all attachments.
    # Lists all attachments.
    # @param id [Integer] The ID of the transaction.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number. The default pagination is 50.
    # @return [AttachmentArray]
    def list_attachment_by_transaction(id, opts = {})
      data, _status_code, _headers = list_attachment_by_transaction_with_http_info(id, opts)
      data
    end

    # Lists all attachments.
    # Lists all attachments.
    # @param id [Integer] The ID of the transaction.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number. The default pagination is 50.
    # @return [Array<(AttachmentArray, Integer, Hash)>] AttachmentArray data, response status code and response headers
    def list_attachment_by_transaction_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionsApi.list_attachment_by_transaction ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling TransactionsApi.list_attachment_by_transaction"
      end
      # resource path
      local_var_path = '/api/v1/transactions/{id}/attachments'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'AttachmentArray'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"TransactionsApi.list_attachment_by_transaction",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionsApi#list_attachment_by_transaction\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Lists all piggy bank events.
    # Lists all piggy bank events.
    # @param id [Integer] The ID of the transaction.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number. The default pagination is 50.
    # @return [PiggyBankEventArray]
    def list_event_by_transaction(id, opts = {})
      data, _status_code, _headers = list_event_by_transaction_with_http_info(id, opts)
      data
    end

    # Lists all piggy bank events.
    # Lists all piggy bank events.
    # @param id [Integer] The ID of the transaction.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number. The default pagination is 50.
    # @return [Array<(PiggyBankEventArray, Integer, Hash)>] PiggyBankEventArray data, response status code and response headers
    def list_event_by_transaction_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionsApi.list_event_by_transaction ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling TransactionsApi.list_event_by_transaction"
      end
      # resource path
      local_var_path = '/api/v1/transactions/{id}/piggy_bank_events'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'PiggyBankEventArray'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"TransactionsApi.list_event_by_transaction",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionsApi#list_event_by_transaction\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List all the user's transactions. 
    # List all the user's transactions.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number. The default pagination is 50.
    # @option opts [Date] :start A date formatted YYYY-MM-DD. This is the start date of the selected range (inclusive). 
    # @option opts [Date] :_end A date formatted YYYY-MM-DD. This is the end date of the selected range (inclusive). 
    # @option opts [TransactionTypeFilter] :type Optional filter on the transaction type(s) returned.
    # @return [TransactionArray]
    def list_transaction(opts = {})
      data, _status_code, _headers = list_transaction_with_http_info(opts)
      data
    end

    # List all the user&#39;s transactions. 
    # List all the user&#39;s transactions.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number. The default pagination is 50.
    # @option opts [Date] :start A date formatted YYYY-MM-DD. This is the start date of the selected range (inclusive). 
    # @option opts [Date] :_end A date formatted YYYY-MM-DD. This is the end date of the selected range (inclusive). 
    # @option opts [TransactionTypeFilter] :type Optional filter on the transaction type(s) returned.
    # @return [Array<(TransactionArray, Integer, Hash)>] TransactionArray data, response status code and response headers
    def list_transaction_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionsApi.list_transaction ...'
      end
      # resource path
      local_var_path = '/api/v1/transactions'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'start'] = opts[:'start'] if !opts[:'start'].nil?
      query_params[:'end'] = opts[:'_end'] if !opts[:'_end'].nil?
      query_params[:'type'] = opts[:'type'] if !opts[:'type'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'TransactionArray'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"TransactionsApi.list_transaction",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionsApi#list_transaction\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Store a new transaction
    # Creates a new transaction. The data required can be submitted as a JSON body or as a list of parameters.
    # @param transaction [Transaction] JSON array or key&#x3D;value pairs with the necessary transaction information. See the model for the exact specifications.
    # @param [Hash] opts the optional parameters
    # @return [TransactionSingle]
    def store_transaction(transaction, opts = {})
      data, _status_code, _headers = store_transaction_with_http_info(transaction, opts)
      data
    end

    # Store a new transaction
    # Creates a new transaction. The data required can be submitted as a JSON body or as a list of parameters.
    # @param transaction [Transaction] JSON array or key&#x3D;value pairs with the necessary transaction information. See the model for the exact specifications.
    # @param [Hash] opts the optional parameters
    # @return [Array<(TransactionSingle, Integer, Hash)>] TransactionSingle data, response status code and response headers
    def store_transaction_with_http_info(transaction, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionsApi.store_transaction ...'
      end
      # verify the required parameter 'transaction' is set
      if @api_client.config.client_side_validation && transaction.nil?
        fail ArgumentError, "Missing the required parameter 'transaction' when calling TransactionsApi.store_transaction"
      end
      # resource path
      local_var_path = '/api/v1/transactions'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(transaction)

      # return_type
      return_type = opts[:debug_return_type] || 'TransactionSingle'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"TransactionsApi.store_transaction",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionsApi#store_transaction\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update existing transaction.
    # Update an existing transaction.
    # @param id [Integer] The ID of the transaction.
    # @param transaction [Transaction] JSON array with updated transaction information. See the model for the exact specifications.
    # @param [Hash] opts the optional parameters
    # @return [TransactionSingle]
    def update_transaction(id, transaction, opts = {})
      data, _status_code, _headers = update_transaction_with_http_info(id, transaction, opts)
      data
    end

    # Update existing transaction.
    # Update an existing transaction.
    # @param id [Integer] The ID of the transaction.
    # @param transaction [Transaction] JSON array with updated transaction information. See the model for the exact specifications.
    # @param [Hash] opts the optional parameters
    # @return [Array<(TransactionSingle, Integer, Hash)>] TransactionSingle data, response status code and response headers
    def update_transaction_with_http_info(id, transaction, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionsApi.update_transaction ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling TransactionsApi.update_transaction"
      end
      # verify the required parameter 'transaction' is set
      if @api_client.config.client_side_validation && transaction.nil?
        fail ArgumentError, "Missing the required parameter 'transaction' when calling TransactionsApi.update_transaction"
      end
      # resource path
      local_var_path = '/api/v1/transactions/{id}'.sub('{' + 'id' + '}', CGI.escape(id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(transaction)

      # return_type
      return_type = opts[:debug_return_type] || 'TransactionSingle'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['firefly_iii_auth']

      new_options = opts.merge(
        :operation => :"TransactionsApi.update_transaction",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionsApi#update_transaction\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
