=begin
#Firefly III API

#This is the official documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. This version of the API is live from version v4.7.9 and onwards. You may use the \"Authorize\" button to try the API below. 

The version of the OpenAPI document: 0.10.4-modified
Contact: thegrumpydictator@gmail.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0-SNAPSHOT

=end

require 'date'
require 'time'

module FireflyIIIClient
  class Account
    attr_accessor :created_at

    attr_accessor :updated_at

    attr_accessor :name

    # Can only be one one these account types. import, initial-balance and reconciliation cannot be set manually.
    attr_accessor :type

    attr_accessor :iban

    attr_accessor :bic

    attr_accessor :account_number

    attr_accessor :opening_balance

    attr_accessor :opening_balance_date

    attr_accessor :virtual_balance

    attr_accessor :current_balance

    attr_accessor :current_balance_date

    # Use either currency_id or currency_code. Defaults to the user's default currency.
    attr_accessor :currency_id

    # Use either currency_id or currency_code. Defaults to the user's default currency.
    attr_accessor :currency_code

    attr_accessor :currency_symbol

    attr_accessor :currency_decimal_places

    # If omitted, defaults to true.
    attr_accessor :active

    # If omitted, defaults to true.
    attr_accessor :include_net_worth

    # Is only mandatory when the type is asset.
    attr_accessor :account_role

    # Mandatory when the account_role is ccAsset. Can only be monthlyFull.
    attr_accessor :credit_card_type

    # Mandatory when the account_role is ccAsset. Moment at which CC payment installments are asked for by the bank.
    attr_accessor :monthly_payment_date

    # Mandatory when type is liability. Specifies the exact type.
    attr_accessor :liability_type

    # Mandatory when type is liability. Amount of money in the liability. Must be positive.
    attr_accessor :liability_amount

    # Mandatory when type is liability. Start date for the liability.
    attr_accessor :liability_start_date

    # Mandatory when type is liability. Interest percentage.
    attr_accessor :interest

    # Mandatory when type is liability. Period over which the interest is calculated.
    attr_accessor :interest_period

    attr_accessor :notes

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'created_at' => :'created_at',
        :'updated_at' => :'updated_at',
        :'name' => :'name',
        :'type' => :'type',
        :'iban' => :'iban',
        :'bic' => :'bic',
        :'account_number' => :'account_number',
        :'opening_balance' => :'opening_balance',
        :'opening_balance_date' => :'opening_balance_date',
        :'virtual_balance' => :'virtual_balance',
        :'current_balance' => :'current_balance',
        :'current_balance_date' => :'current_balance_date',
        :'currency_id' => :'currency_id',
        :'currency_code' => :'currency_code',
        :'currency_symbol' => :'currency_symbol',
        :'currency_decimal_places' => :'currency_decimal_places',
        :'active' => :'active',
        :'include_net_worth' => :'include_net_worth',
        :'account_role' => :'account_role',
        :'credit_card_type' => :'credit_card_type',
        :'monthly_payment_date' => :'monthly_payment_date',
        :'liability_type' => :'liability_type',
        :'liability_amount' => :'liability_amount',
        :'liability_start_date' => :'liability_start_date',
        :'interest' => :'interest',
        :'interest_period' => :'interest_period',
        :'notes' => :'notes'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'created_at' => :'Time',
        :'updated_at' => :'Time',
        :'name' => :'String',
        :'type' => :'String',
        :'iban' => :'String',
        :'bic' => :'String',
        :'account_number' => :'String',
        :'opening_balance' => :'Float',
        :'opening_balance_date' => :'Date',
        :'virtual_balance' => :'Float',
        :'current_balance' => :'Float',
        :'current_balance_date' => :'Date',
        :'currency_id' => :'Integer',
        :'currency_code' => :'String',
        :'currency_symbol' => :'String',
        :'currency_decimal_places' => :'Integer',
        :'active' => :'Boolean',
        :'include_net_worth' => :'Boolean',
        :'account_role' => :'String',
        :'credit_card_type' => :'String',
        :'monthly_payment_date' => :'Date',
        :'liability_type' => :'String',
        :'liability_amount' => :'Float',
        :'liability_start_date' => :'Date',
        :'interest' => :'Float',
        :'interest_period' => :'String',
        :'notes' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
        :'credit_card_type',
        :'monthly_payment_date',
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `FireflyIIIClient::Account` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `FireflyIIIClient::Account`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'created_at')
        self.created_at = attributes[:'created_at']
      end

      if attributes.key?(:'updated_at')
        self.updated_at = attributes[:'updated_at']
      end

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.key?(:'type')
        self.type = attributes[:'type']
      end

      if attributes.key?(:'iban')
        self.iban = attributes[:'iban']
      end

      if attributes.key?(:'bic')
        self.bic = attributes[:'bic']
      end

      if attributes.key?(:'account_number')
        self.account_number = attributes[:'account_number']
      end

      if attributes.key?(:'opening_balance')
        self.opening_balance = attributes[:'opening_balance']
      end

      if attributes.key?(:'opening_balance_date')
        self.opening_balance_date = attributes[:'opening_balance_date']
      end

      if attributes.key?(:'virtual_balance')
        self.virtual_balance = attributes[:'virtual_balance']
      end

      if attributes.key?(:'current_balance')
        self.current_balance = attributes[:'current_balance']
      end

      if attributes.key?(:'current_balance_date')
        self.current_balance_date = attributes[:'current_balance_date']
      end

      if attributes.key?(:'currency_id')
        self.currency_id = attributes[:'currency_id']
      end

      if attributes.key?(:'currency_code')
        self.currency_code = attributes[:'currency_code']
      end

      if attributes.key?(:'currency_symbol')
        self.currency_symbol = attributes[:'currency_symbol']
      end

      if attributes.key?(:'currency_decimal_places')
        self.currency_decimal_places = attributes[:'currency_decimal_places']
      end

      if attributes.key?(:'active')
        self.active = attributes[:'active']
      end

      if attributes.key?(:'include_net_worth')
        self.include_net_worth = attributes[:'include_net_worth']
      end

      if attributes.key?(:'account_role')
        self.account_role = attributes[:'account_role']
      end

      if attributes.key?(:'credit_card_type')
        self.credit_card_type = attributes[:'credit_card_type']
      end

      if attributes.key?(:'monthly_payment_date')
        self.monthly_payment_date = attributes[:'monthly_payment_date']
      end

      if attributes.key?(:'liability_type')
        self.liability_type = attributes[:'liability_type']
      end

      if attributes.key?(:'liability_amount')
        self.liability_amount = attributes[:'liability_amount']
      end

      if attributes.key?(:'liability_start_date')
        self.liability_start_date = attributes[:'liability_start_date']
      end

      if attributes.key?(:'interest')
        self.interest = attributes[:'interest']
      end

      if attributes.key?(:'interest_period')
        self.interest_period = attributes[:'interest_period']
      end

      if attributes.key?(:'notes')
        self.notes = attributes[:'notes']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if @type.nil?
        invalid_properties.push('invalid value for "type", type cannot be nil.')
      end

      if @account_role.nil?
        invalid_properties.push('invalid value for "account_role", account_role cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @name.nil?
      return false if @type.nil?
      type_validator = EnumAttributeValidator.new('String', ["asset", "expense", "import", "revenue", "cash", "liability", "liabilities", "initial-balance", "reconciliation"])
      return false unless type_validator.valid?(@type)
      return false if @account_role.nil?
      account_role_validator = EnumAttributeValidator.new('String', ["defaultAsset", "sharedAsset", "savingAsset", "ccAsset", "cashWalletAsset"])
      return false unless account_role_validator.valid?(@account_role)
      credit_card_type_validator = EnumAttributeValidator.new('String', ["monthlyFull"])
      return false unless credit_card_type_validator.valid?(@credit_card_type)
      liability_type_validator = EnumAttributeValidator.new('String', ["loan", "debt", "mortgage"])
      return false unless liability_type_validator.valid?(@liability_type)
      interest_period_validator = EnumAttributeValidator.new('String', ["daily", "monthly", "yearly"])
      return false unless interest_period_validator.valid?(@interest_period)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] type Object to be assigned
    def type=(type)
      validator = EnumAttributeValidator.new('String', ["asset", "expense", "import", "revenue", "cash", "liability", "liabilities", "initial-balance", "reconciliation"])
      unless validator.valid?(type)
        fail ArgumentError, "invalid value for \"type\", must be one of #{validator.allowable_values}."
      end
      @type = type
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] account_role Object to be assigned
    def account_role=(account_role)
      validator = EnumAttributeValidator.new('String', ["defaultAsset", "sharedAsset", "savingAsset", "ccAsset", "cashWalletAsset"])
      unless validator.valid?(account_role)
        fail ArgumentError, "invalid value for \"account_role\", must be one of #{validator.allowable_values}."
      end
      @account_role = account_role
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] credit_card_type Object to be assigned
    def credit_card_type=(credit_card_type)
      validator = EnumAttributeValidator.new('String', ["monthlyFull"])
      unless validator.valid?(credit_card_type)
        fail ArgumentError, "invalid value for \"credit_card_type\", must be one of #{validator.allowable_values}."
      end
      @credit_card_type = credit_card_type
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] liability_type Object to be assigned
    def liability_type=(liability_type)
      validator = EnumAttributeValidator.new('String', ["loan", "debt", "mortgage"])
      unless validator.valid?(liability_type)
        fail ArgumentError, "invalid value for \"liability_type\", must be one of #{validator.allowable_values}."
      end
      @liability_type = liability_type
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] interest_period Object to be assigned
    def interest_period=(interest_period)
      validator = EnumAttributeValidator.new('String', ["daily", "monthly", "yearly"])
      unless validator.valid?(interest_period)
        fail ArgumentError, "invalid value for \"interest_period\", must be one of #{validator.allowable_values}."
      end
      @interest_period = interest_period
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          created_at == o.created_at &&
          updated_at == o.updated_at &&
          name == o.name &&
          type == o.type &&
          iban == o.iban &&
          bic == o.bic &&
          account_number == o.account_number &&
          opening_balance == o.opening_balance &&
          opening_balance_date == o.opening_balance_date &&
          virtual_balance == o.virtual_balance &&
          current_balance == o.current_balance &&
          current_balance_date == o.current_balance_date &&
          currency_id == o.currency_id &&
          currency_code == o.currency_code &&
          currency_symbol == o.currency_symbol &&
          currency_decimal_places == o.currency_decimal_places &&
          active == o.active &&
          include_net_worth == o.include_net_worth &&
          account_role == o.account_role &&
          credit_card_type == o.credit_card_type &&
          monthly_payment_date == o.monthly_payment_date &&
          liability_type == o.liability_type &&
          liability_amount == o.liability_amount &&
          liability_start_date == o.liability_start_date &&
          interest == o.interest &&
          interest_period == o.interest_period &&
          notes == o.notes
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [created_at, updated_at, name, type, iban, bic, account_number, opening_balance, opening_balance_date, virtual_balance, current_balance, current_balance_date, currency_id, currency_code, currency_symbol, currency_decimal_places, active, include_net_worth, account_role, credit_card_type, monthly_payment_date, liability_type, liability_amount, liability_start_date, interest, interest_period, notes].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = FireflyIIIClient.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
