=begin
#Firefly III API

#This is the official documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. This version of the API is live from version v4.7.9 and onwards. You may use the \"Authorize\" button to try the API below. 

The version of the OpenAPI document: 0.10.4-modified
Contact: thegrumpydictator@gmail.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0-SNAPSHOT

=end

require 'date'
require 'time'

module FireflyIIIClient
  class Bill
    attr_accessor :created_at

    attr_accessor :updated_at

    # Use either currency_id or currency_code
    attr_accessor :currency_id

    # Use either currency_id or currency_code
    attr_accessor :currency_code

    attr_accessor :currency_symbol

    attr_accessor :currency_decimal_places

    attr_accessor :name

    attr_accessor :amount_min

    attr_accessor :amount_max

    attr_accessor :date

    # How often the bill must be paid.
    attr_accessor :repeat_freq

    # How often the bill must be skipped. 1 means a bi-monthly bill.
    attr_accessor :skip

    # If the bill is active.
    attr_accessor :active

    attr_accessor :notes

    # When the bill is expected to be due.
    attr_accessor :next_expected_match

    # Array of future dates when the bill is expected to be paid. Autogenerated.
    attr_accessor :pay_dates

    # Array of past transactions when the bill was paid.
    attr_accessor :paid_dates

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'created_at' => :'created_at',
        :'updated_at' => :'updated_at',
        :'currency_id' => :'currency_id',
        :'currency_code' => :'currency_code',
        :'currency_symbol' => :'currency_symbol',
        :'currency_decimal_places' => :'currency_decimal_places',
        :'name' => :'name',
        :'amount_min' => :'amount_min',
        :'amount_max' => :'amount_max',
        :'date' => :'date',
        :'repeat_freq' => :'repeat_freq',
        :'skip' => :'skip',
        :'active' => :'active',
        :'notes' => :'notes',
        :'next_expected_match' => :'next_expected_match',
        :'pay_dates' => :'pay_dates',
        :'paid_dates' => :'paid_dates'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'created_at' => :'Time',
        :'updated_at' => :'Time',
        :'currency_id' => :'Integer',
        :'currency_code' => :'String',
        :'currency_symbol' => :'String',
        :'currency_decimal_places' => :'Integer',
        :'name' => :'String',
        :'amount_min' => :'Float',
        :'amount_max' => :'Float',
        :'date' => :'Date',
        :'repeat_freq' => :'String',
        :'skip' => :'Integer',
        :'active' => :'Boolean',
        :'notes' => :'String',
        :'next_expected_match' => :'Date',
        :'pay_dates' => :'Array<Date>',
        :'paid_dates' => :'Array<BillPaidDates>'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `FireflyIIIClient::Bill` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `FireflyIIIClient::Bill`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'created_at')
        self.created_at = attributes[:'created_at']
      end

      if attributes.key?(:'updated_at')
        self.updated_at = attributes[:'updated_at']
      end

      if attributes.key?(:'currency_id')
        self.currency_id = attributes[:'currency_id']
      end

      if attributes.key?(:'currency_code')
        self.currency_code = attributes[:'currency_code']
      end

      if attributes.key?(:'currency_symbol')
        self.currency_symbol = attributes[:'currency_symbol']
      end

      if attributes.key?(:'currency_decimal_places')
        self.currency_decimal_places = attributes[:'currency_decimal_places']
      end

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.key?(:'amount_min')
        self.amount_min = attributes[:'amount_min']
      end

      if attributes.key?(:'amount_max')
        self.amount_max = attributes[:'amount_max']
      end

      if attributes.key?(:'date')
        self.date = attributes[:'date']
      end

      if attributes.key?(:'repeat_freq')
        self.repeat_freq = attributes[:'repeat_freq']
      end

      if attributes.key?(:'skip')
        self.skip = attributes[:'skip']
      end

      if attributes.key?(:'active')
        self.active = attributes[:'active']
      end

      if attributes.key?(:'notes')
        self.notes = attributes[:'notes']
      end

      if attributes.key?(:'next_expected_match')
        self.next_expected_match = attributes[:'next_expected_match']
      end

      if attributes.key?(:'pay_dates')
        if (value = attributes[:'pay_dates']).is_a?(Array)
          self.pay_dates = value
        end
      end

      if attributes.key?(:'paid_dates')
        if (value = attributes[:'paid_dates']).is_a?(Array)
          self.paid_dates = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if @amount_min.nil?
        invalid_properties.push('invalid value for "amount_min", amount_min cannot be nil.')
      end

      if @amount_max.nil?
        invalid_properties.push('invalid value for "amount_max", amount_max cannot be nil.')
      end

      if @date.nil?
        invalid_properties.push('invalid value for "date", date cannot be nil.')
      end

      if @repeat_freq.nil?
        invalid_properties.push('invalid value for "repeat_freq", repeat_freq cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @name.nil?
      return false if @amount_min.nil?
      return false if @amount_max.nil?
      return false if @date.nil?
      return false if @repeat_freq.nil?
      repeat_freq_validator = EnumAttributeValidator.new('String', ["weekly", "monthly", "quarterly", "half-year", "yearly"])
      return false unless repeat_freq_validator.valid?(@repeat_freq)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] repeat_freq Object to be assigned
    def repeat_freq=(repeat_freq)
      validator = EnumAttributeValidator.new('String', ["weekly", "monthly", "quarterly", "half-year", "yearly"])
      unless validator.valid?(repeat_freq)
        fail ArgumentError, "invalid value for \"repeat_freq\", must be one of #{validator.allowable_values}."
      end
      @repeat_freq = repeat_freq
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          created_at == o.created_at &&
          updated_at == o.updated_at &&
          currency_id == o.currency_id &&
          currency_code == o.currency_code &&
          currency_symbol == o.currency_symbol &&
          currency_decimal_places == o.currency_decimal_places &&
          name == o.name &&
          amount_min == o.amount_min &&
          amount_max == o.amount_max &&
          date == o.date &&
          repeat_freq == o.repeat_freq &&
          skip == o.skip &&
          active == o.active &&
          notes == o.notes &&
          next_expected_match == o.next_expected_match &&
          pay_dates == o.pay_dates &&
          paid_dates == o.paid_dates
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [created_at, updated_at, currency_id, currency_code, currency_symbol, currency_decimal_places, name, amount_min, amount_max, date, repeat_freq, skip, active, notes, next_expected_match, pay_dates, paid_dates].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = FireflyIIIClient.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
