=begin
#Firefly III API

#This is the official documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. This version of the API is live from version v4.7.9 and onwards. You may use the \"Authorize\" button to try the API below. 

The version of the OpenAPI document: 0.10.4-modified
Contact: thegrumpydictator@gmail.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0-SNAPSHOT

=end

require 'date'
require 'time'

module FireflyIIIClient
  class PiggyBank
    attr_accessor :created_at

    attr_accessor :updated_at

    attr_accessor :name

    # The ID of the asset account this piggy bank is connected to.
    attr_accessor :account_id

    # The name of the asset account this piggy bank is connected to.
    attr_accessor :account_name

    attr_accessor :currency_id

    attr_accessor :currency_code

    attr_accessor :currency_symbol

    # Number of decimals supported by the currency
    attr_accessor :currency_decimal_places

    attr_accessor :target_amount

    attr_accessor :percentage

    attr_accessor :current_amount

    attr_accessor :left_to_save

    attr_accessor :save_per_month

    # The date you started with this piggy bank.
    attr_accessor :start_date

    # The date you intend to finish saving money.
    attr_accessor :target_date

    attr_accessor :order

    attr_accessor :active

    attr_accessor :notes

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'created_at' => :'created_at',
        :'updated_at' => :'updated_at',
        :'name' => :'name',
        :'account_id' => :'account_id',
        :'account_name' => :'account_name',
        :'currency_id' => :'currency_id',
        :'currency_code' => :'currency_code',
        :'currency_symbol' => :'currency_symbol',
        :'currency_decimal_places' => :'currency_decimal_places',
        :'target_amount' => :'target_amount',
        :'percentage' => :'percentage',
        :'current_amount' => :'current_amount',
        :'left_to_save' => :'left_to_save',
        :'save_per_month' => :'save_per_month',
        :'start_date' => :'start_date',
        :'target_date' => :'target_date',
        :'order' => :'order',
        :'active' => :'active',
        :'notes' => :'notes'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'created_at' => :'Time',
        :'updated_at' => :'Time',
        :'name' => :'String',
        :'account_id' => :'Integer',
        :'account_name' => :'String',
        :'currency_id' => :'Integer',
        :'currency_code' => :'String',
        :'currency_symbol' => :'String',
        :'currency_decimal_places' => :'Integer',
        :'target_amount' => :'Float',
        :'percentage' => :'Float',
        :'current_amount' => :'Float',
        :'left_to_save' => :'Float',
        :'save_per_month' => :'Float',
        :'start_date' => :'Date',
        :'target_date' => :'Date',
        :'order' => :'Integer',
        :'active' => :'Boolean',
        :'notes' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `FireflyIIIClient::PiggyBank` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `FireflyIIIClient::PiggyBank`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'created_at')
        self.created_at = attributes[:'created_at']
      end

      if attributes.key?(:'updated_at')
        self.updated_at = attributes[:'updated_at']
      end

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.key?(:'account_id')
        self.account_id = attributes[:'account_id']
      end

      if attributes.key?(:'account_name')
        self.account_name = attributes[:'account_name']
      end

      if attributes.key?(:'currency_id')
        self.currency_id = attributes[:'currency_id']
      end

      if attributes.key?(:'currency_code')
        self.currency_code = attributes[:'currency_code']
      end

      if attributes.key?(:'currency_symbol')
        self.currency_symbol = attributes[:'currency_symbol']
      end

      if attributes.key?(:'currency_decimal_places')
        self.currency_decimal_places = attributes[:'currency_decimal_places']
      end

      if attributes.key?(:'target_amount')
        self.target_amount = attributes[:'target_amount']
      end

      if attributes.key?(:'percentage')
        self.percentage = attributes[:'percentage']
      end

      if attributes.key?(:'current_amount')
        self.current_amount = attributes[:'current_amount']
      end

      if attributes.key?(:'left_to_save')
        self.left_to_save = attributes[:'left_to_save']
      end

      if attributes.key?(:'save_per_month')
        self.save_per_month = attributes[:'save_per_month']
      end

      if attributes.key?(:'start_date')
        self.start_date = attributes[:'start_date']
      end

      if attributes.key?(:'target_date')
        self.target_date = attributes[:'target_date']
      end

      if attributes.key?(:'order')
        self.order = attributes[:'order']
      end

      if attributes.key?(:'active')
        self.active = attributes[:'active']
      end

      if attributes.key?(:'notes')
        self.notes = attributes[:'notes']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if @account_id.nil?
        invalid_properties.push('invalid value for "account_id", account_id cannot be nil.')
      end

      if @target_amount.nil?
        invalid_properties.push('invalid value for "target_amount", target_amount cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @name.nil?
      return false if @account_id.nil?
      return false if @target_amount.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          created_at == o.created_at &&
          updated_at == o.updated_at &&
          name == o.name &&
          account_id == o.account_id &&
          account_name == o.account_name &&
          currency_id == o.currency_id &&
          currency_code == o.currency_code &&
          currency_symbol == o.currency_symbol &&
          currency_decimal_places == o.currency_decimal_places &&
          target_amount == o.target_amount &&
          percentage == o.percentage &&
          current_amount == o.current_amount &&
          left_to_save == o.left_to_save &&
          save_per_month == o.save_per_month &&
          start_date == o.start_date &&
          target_date == o.target_date &&
          order == o.order &&
          active == o.active &&
          notes == o.notes
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [created_at, updated_at, name, account_id, account_name, currency_id, currency_code, currency_symbol, currency_decimal_places, target_amount, percentage, current_amount, left_to_save, save_per_month, start_date, target_date, order, active, notes].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = FireflyIIIClient.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
