=begin
#Firefly III API

#This is the official documentation of the Firefly III API. You can find accompanying documentation on the website of Firefly III itself (see below). Please report any bugs or issues. This version of the API is live from version v4.7.9 and onwards. You may use the \"Authorize\" button to try the API below. 

The version of the OpenAPI document: 0.10.4-modified
Contact: thegrumpydictator@gmail.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0-SNAPSHOT

=end

require 'date'
require 'time'

module FireflyIIIClient
  class RecurrenceTransaction
    attr_accessor :description

    # Amount of the transaction.
    attr_accessor :amount

    # Foreign amount of the transaction.
    attr_accessor :foreign_amount

    # Submit either a currency_id or a currency_code.
    attr_accessor :currency_id

    # Submit either a currency_id or a currency_code.
    attr_accessor :currency_code

    attr_accessor :currency_symbol

    # Number of decimals in the currency
    attr_accessor :currency_decimal_places

    # Submit either a foreign_currency_id or a foreign_currency_code, or neither.
    attr_accessor :foreign_currency_id

    # Submit either a foreign_currency_id or a foreign_currency_code, or neither.
    attr_accessor :foreign_currency_code

    attr_accessor :foreign_currency_symbol

    # Number of decimals in the currency
    attr_accessor :foreign_currency_decimal_places

    # The budget ID for this transaction.
    attr_accessor :budget_id

    # The name of the budget to be used. If the budget name is unknown, the ID will be used or the value will be ignored.
    attr_accessor :budget_name

    # Category ID for this transaction.
    attr_accessor :category_id

    # Category name for this transaction.
    attr_accessor :category_name

    # ID of the source account. Submit either this or source_name.
    attr_accessor :source_id

    # Name of the source account. Submit either this or source_id.
    attr_accessor :source_name

    attr_accessor :source_iban

    attr_accessor :source_type

    # ID of the destination account. Submit either this or destination_name.
    attr_accessor :destination_id

    # Name of the destination account. Submit either this or destination_id.
    attr_accessor :destination_name

    attr_accessor :destination_iban

    attr_accessor :destination_type

    # Array of tags.
    attr_accessor :tags

    # Optional. Use either this or the piggy_bank_name
    attr_accessor :piggy_bank_id

    # Optional. Use either this or the piggy_bank_id
    attr_accessor :piggy_bank_name

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'description' => :'description',
        :'amount' => :'amount',
        :'foreign_amount' => :'foreign_amount',
        :'currency_id' => :'currency_id',
        :'currency_code' => :'currency_code',
        :'currency_symbol' => :'currency_symbol',
        :'currency_decimal_places' => :'currency_decimal_places',
        :'foreign_currency_id' => :'foreign_currency_id',
        :'foreign_currency_code' => :'foreign_currency_code',
        :'foreign_currency_symbol' => :'foreign_currency_symbol',
        :'foreign_currency_decimal_places' => :'foreign_currency_decimal_places',
        :'budget_id' => :'budget_id',
        :'budget_name' => :'budget_name',
        :'category_id' => :'category_id',
        :'category_name' => :'category_name',
        :'source_id' => :'source_id',
        :'source_name' => :'source_name',
        :'source_iban' => :'source_iban',
        :'source_type' => :'source_type',
        :'destination_id' => :'destination_id',
        :'destination_name' => :'destination_name',
        :'destination_iban' => :'destination_iban',
        :'destination_type' => :'destination_type',
        :'tags' => :'tags',
        :'piggy_bank_id' => :'piggy_bank_id',
        :'piggy_bank_name' => :'piggy_bank_name'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'description' => :'String',
        :'amount' => :'Float',
        :'foreign_amount' => :'Float',
        :'currency_id' => :'Integer',
        :'currency_code' => :'String',
        :'currency_symbol' => :'String',
        :'currency_decimal_places' => :'Integer',
        :'foreign_currency_id' => :'Integer',
        :'foreign_currency_code' => :'String',
        :'foreign_currency_symbol' => :'String',
        :'foreign_currency_decimal_places' => :'Integer',
        :'budget_id' => :'Integer',
        :'budget_name' => :'String',
        :'category_id' => :'Integer',
        :'category_name' => :'String',
        :'source_id' => :'Integer',
        :'source_name' => :'String',
        :'source_iban' => :'String',
        :'source_type' => :'AccountTypeProperty',
        :'destination_id' => :'Integer',
        :'destination_name' => :'String',
        :'destination_iban' => :'String',
        :'destination_type' => :'AccountTypeProperty',
        :'tags' => :'Array<String>',
        :'piggy_bank_id' => :'Integer',
        :'piggy_bank_name' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
        :'foreign_amount',
        :'foreign_currency_id',
        :'foreign_currency_code',
        :'foreign_currency_symbol',
        :'foreign_currency_decimal_places',
        :'budget_name',
        :'source_iban',
        :'destination_iban',
        :'tags',
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `FireflyIIIClient::RecurrenceTransaction` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `FireflyIIIClient::RecurrenceTransaction`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.key?(:'amount')
        self.amount = attributes[:'amount']
      end

      if attributes.key?(:'foreign_amount')
        self.foreign_amount = attributes[:'foreign_amount']
      end

      if attributes.key?(:'currency_id')
        self.currency_id = attributes[:'currency_id']
      end

      if attributes.key?(:'currency_code')
        self.currency_code = attributes[:'currency_code']
      end

      if attributes.key?(:'currency_symbol')
        self.currency_symbol = attributes[:'currency_symbol']
      end

      if attributes.key?(:'currency_decimal_places')
        self.currency_decimal_places = attributes[:'currency_decimal_places']
      end

      if attributes.key?(:'foreign_currency_id')
        self.foreign_currency_id = attributes[:'foreign_currency_id']
      end

      if attributes.key?(:'foreign_currency_code')
        self.foreign_currency_code = attributes[:'foreign_currency_code']
      end

      if attributes.key?(:'foreign_currency_symbol')
        self.foreign_currency_symbol = attributes[:'foreign_currency_symbol']
      end

      if attributes.key?(:'foreign_currency_decimal_places')
        self.foreign_currency_decimal_places = attributes[:'foreign_currency_decimal_places']
      end

      if attributes.key?(:'budget_id')
        self.budget_id = attributes[:'budget_id']
      end

      if attributes.key?(:'budget_name')
        self.budget_name = attributes[:'budget_name']
      end

      if attributes.key?(:'category_id')
        self.category_id = attributes[:'category_id']
      end

      if attributes.key?(:'category_name')
        self.category_name = attributes[:'category_name']
      end

      if attributes.key?(:'source_id')
        self.source_id = attributes[:'source_id']
      end

      if attributes.key?(:'source_name')
        self.source_name = attributes[:'source_name']
      end

      if attributes.key?(:'source_iban')
        self.source_iban = attributes[:'source_iban']
      end

      if attributes.key?(:'source_type')
        self.source_type = attributes[:'source_type']
      end

      if attributes.key?(:'destination_id')
        self.destination_id = attributes[:'destination_id']
      end

      if attributes.key?(:'destination_name')
        self.destination_name = attributes[:'destination_name']
      end

      if attributes.key?(:'destination_iban')
        self.destination_iban = attributes[:'destination_iban']
      end

      if attributes.key?(:'destination_type')
        self.destination_type = attributes[:'destination_type']
      end

      if attributes.key?(:'tags')
        if (value = attributes[:'tags']).is_a?(Array)
          self.tags = value
        end
      end

      if attributes.key?(:'piggy_bank_id')
        self.piggy_bank_id = attributes[:'piggy_bank_id']
      end

      if attributes.key?(:'piggy_bank_name')
        self.piggy_bank_name = attributes[:'piggy_bank_name']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @description.nil?
        invalid_properties.push('invalid value for "description", description cannot be nil.')
      end

      if @amount.nil?
        invalid_properties.push('invalid value for "amount", amount cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @description.nil?
      return false if @amount.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          description == o.description &&
          amount == o.amount &&
          foreign_amount == o.foreign_amount &&
          currency_id == o.currency_id &&
          currency_code == o.currency_code &&
          currency_symbol == o.currency_symbol &&
          currency_decimal_places == o.currency_decimal_places &&
          foreign_currency_id == o.foreign_currency_id &&
          foreign_currency_code == o.foreign_currency_code &&
          foreign_currency_symbol == o.foreign_currency_symbol &&
          foreign_currency_decimal_places == o.foreign_currency_decimal_places &&
          budget_id == o.budget_id &&
          budget_name == o.budget_name &&
          category_id == o.category_id &&
          category_name == o.category_name &&
          source_id == o.source_id &&
          source_name == o.source_name &&
          source_iban == o.source_iban &&
          source_type == o.source_type &&
          destination_id == o.destination_id &&
          destination_name == o.destination_name &&
          destination_iban == o.destination_iban &&
          destination_type == o.destination_type &&
          tags == o.tags &&
          piggy_bank_id == o.piggy_bank_id &&
          piggy_bank_name == o.piggy_bank_name
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [description, amount, foreign_amount, currency_id, currency_code, currency_symbol, currency_decimal_places, foreign_currency_id, foreign_currency_code, foreign_currency_symbol, foreign_currency_decimal_places, budget_id, budget_name, category_id, category_name, source_id, source_name, source_iban, source_type, destination_id, destination_name, destination_iban, destination_type, tags, piggy_bank_id, piggy_bank_name].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = FireflyIIIClient.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
